#! /bin/sh  

kernel_version=`cat /proc/version | awk '{print $3}'`
ver=${kernel_version:0:1}

if [ $ver -eq '3' ] ; then
	echo "kernel 3"
else	
	echo "kernel 2"
fi
 
if [ $# -eq 0 ] && [ -f /opt/wifi/wifi_en ] && [ -f /opt/wifi/wpa_supplicant.conf ]; then
	killall udhcpc wpa_supplicant

	if [ $ver -eq '3' ] ; then
		wpa_supplicant -B -Dnl80211 -iwlan0 -c/opt/wifi/wpa_supplicant.conf
	else	
		wpa_supplicant -B -Dwext -iwlan0 -c /opt/wifi/wpa_supplicant.conf
	fi
	
	sleep 10
	udhcpc -i wlan0 & { sleep 30; kill $! & }
	exit -1
fi

if [ $# -eq 0 ]; then
	echo "param error!"
	exit -1
fi

if [ $1 = 0 ]; then
	echo "wifi disabled!"
	echo "" >  /opt/wifi/wpa_supplicant.conf
	rm /opt/wifi/wifi_en
	killall wpa_supplicant
	exit -1
fi

if [ $1 = 1 ] && [ $# -eq 1 ]; then
	echo "param error!"
	exit -1
fi


if [ $# -eq 2 ]; then
	mkdir /opt/wifi
	touch /opt/wifi/wpa_supplicant.conf 
	echo "ctrl_interface=/var/run/wpa_supplicant" >  /opt/wifi/wpa_supplicant.conf 
	echo "" > /opt/wifi/wifi_en
	echo "network={" >> /opt/wifi/wpa_supplicant.conf 
	echo "	ssid=\"$2\"" >> /opt/wifi/wpa_supplicant.conf 
	echo "	key_mgmt=NONE " >> /opt/wifi/wpa_supplicant.conf 
	echo "}" >> /opt/wifi/wpa_supplicant.conf 
elif [ $# -gt 2 ]; then
	mkdir /opt/wifi
	touch /opt/wifi/wpa_supplicant.conf 
	echo "ctrl_interface=/var/run/wpa_supplicant" >  /opt/wifi/wpa_supplicant.conf 
	echo "" > /opt/wifi/wifi_en
	echo "network={" >> /opt/wifi/wpa_supplicant.conf 
	echo "	ssid=\"$2\"" >> /opt/wifi/wpa_supplicant.conf 
	echo "	psk=\"$3\"" >> /opt/wifi/wpa_supplicant.conf 
	echo "}" >> /opt/wifi/wpa_supplicant.conf 
fi

killall udhcpc wpa_supplicant
if [ $ver -eq '3' ] ; then
	wpa_supplicant -B -Dnl80211 -iwlan0 -c/opt/wifi/wpa_supplicant.conf
else	
	wpa_supplicant -B -Dwext -iwlan0 -c /opt/wifi/wpa_supplicant.conf
fi
sleep 10
udhcpc -i wlan0 & { sleep 40; kill $! & }
#udhcpc -i wlan0

echo "done..."
